//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%40AE265101CD.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%40AE265101CD.cm

//## begin module%40AE265101CD.cp preserve=no
//## end module%40AE265101CD.cp

//## Module: SignalHandler%40AE265101CD; Package body
//## Subsystem: XSUtil::Signals%40AE2614008B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Signals/SignalHandler.cxx

//## begin module%40AE265101CD.additionalIncludes preserve=no
//## end module%40AE265101CD.additionalIncludes

//## begin module%40AE265101CD.includes preserve=yes
//## end module%40AE265101CD.includes

// SignalHandler
#include <XSUtil/Signals/SignalHandler.h>
//## begin module%40AE265101CD.declarations preserve=no
//## end module%40AE265101CD.declarations

//## begin module%40AE265101CD.additionalDeclarations preserve=yes
//## end module%40AE265101CD.additionalDeclarations


// Class SignalHandler 

//## begin SignalHandler::instance%40AE29070283.attr preserve=no  private: static SignalHandler* {U} 0
SignalHandler* SignalHandler::s_instance = 0;
//## end SignalHandler::instance%40AE29070283.attr

//## begin SignalHandler::signalHandlers%40AE2FD00223.attr preserve=no  private: static std::map<int,EventHandler*> {U} std::map<int,EventHandler*>()
std::map<int,EventHandler*> SignalHandler::s_signalHandlers = std::map<int,EventHandler*>();
//## end SignalHandler::signalHandlers%40AE2FD00223.attr

SignalHandler::SignalHandler()
  //## begin SignalHandler::SignalHandler%40AE27630204_const.hasinit preserve=no
  //## end SignalHandler::SignalHandler%40AE27630204_const.hasinit
  //## begin SignalHandler::SignalHandler%40AE27630204_const.initialization preserve=yes
  //## end SignalHandler::SignalHandler%40AE27630204_const.initialization
{
  //## begin SignalHandler::SignalHandler%40AE27630204_const.body preserve=yes
  //## end SignalHandler::SignalHandler%40AE27630204_const.body
}


SignalHandler::~SignalHandler()
{
  //## begin SignalHandler::~SignalHandler%40AE27630204_dest.body preserve=yes
   // SignalHandler container doesn't strictly own the EventHandlers
   // residing in its map.  Clients are able to replace EventHandler
   // pointers when they call registerHandler, in which case they
   // are responsible for that EventHandler's memory.  At any
   // rate, if any EventHandlers are still around by this point,
   // zap 'em.
   std::map<int,EventHandler*>::iterator it = s_signalHandlers.begin();
   while (it != s_signalHandlers.end())
   {
      delete it->second;
      ++it;
   }
  //## end SignalHandler::~SignalHandler%40AE27630204_dest.body
}



//## Other Operations (implementation)
SignalHandler* SignalHandler::instance ()
{
  //## begin SignalHandler::instance%40AE282E0381.body preserve=yes
   if (s_instance == 0)
   {
      s_instance = new SignalHandler;
   }
   return s_instance;
  //## end SignalHandler::instance%40AE282E0381.body
}

EventHandler* SignalHandler::registerHandler (int sigNum, EventHandler* eh)
{
  //## begin SignalHandler::registerHandler%40AE29F102E9.body preserve=yes
  std::map<int,EventHandler*>::iterator it = s_signalHandlers.find(sigNum);
  EventHandler* oldEh = (it == s_signalHandlers.end()) ? 0 : it->second;
  s_signalHandlers[sigNum] = eh;
  
#ifdef HAVE_SIGSET
  sigset(sigNum, SignalHandler::dispatcher);
#else
  signal(sigNum, SignalHandler::dispatcher);
#endif
  
  return oldEh;
  //## end SignalHandler::registerHandler%40AE29F102E9.body
}

int SignalHandler::removeHandler (int sigNum)
{
  //## begin SignalHandler::removeHandler%40AE2A5E01AF.body preserve=yes
  std::map<int,EventHandler*>::iterator it = s_signalHandlers.find(sigNum);
  int removed = 0;
  if (it != s_signalHandlers.end())
  {
     delete it->second;
     removed = s_signalHandlers.erase(sigNum);
  }
  return removed;
  //## end SignalHandler::removeHandler%40AE2A5E01AF.body
}

void SignalHandler::dispatcher (int sigNum)
{
  //## begin SignalHandler::dispatcher%40AE2A8C02A0.body preserve=yes
  if (s_signalHandlers.find(sigNum) != s_signalHandlers.end())
  {
     s_signalHandlers[sigNum]->handleSignal(sigNum);
  }
  //## end SignalHandler::dispatcher%40AE2A8C02A0.body
}

const EventHandler* SignalHandler::getHandler (int sigNum)
{
  //## begin SignalHandler::getHandler%40B4ABB1014E.body preserve=yes
  std::map<int,EventHandler*>::const_iterator it = s_signalHandlers.find(sigNum);
  if (it == s_signalHandlers.end())
  {
     return 0;
  }
  else
  {
     return it->second;
  }
  //## end SignalHandler::getHandler%40B4ABB1014E.body
}

// Additional Declarations
  //## begin SignalHandler%40AE27630204.declarations preserve=yes
  //## end SignalHandler%40AE27630204.declarations

//## begin module%40AE265101CD.epilog preserve=yes
//## end module%40AE265101CD.epilog
